

#ifndef ____InstallApi__H___
#define ____InstallApi__H___

#include "windows.h"

#ifndef DWORD
  #define DWORD unsigned long 
#endif

#ifdef RK4_INSTDLL 
#define INSTAPI  extern "C" __declspec(dllexport)
#else
#define INSTAPI  extern "C" __declspec(dllimport)
#endif

///The macro defined for Rockey4 install and uninstall
#define  Install_Rockey4	              1   ///Install ROCKEY4 driver
#define  Delete_Rockey4		              2   ///Uninstall ROCKEY4 driver
#define  SupportDos_Rockey4		      4   ///Support dos utility
#define  IsContinueIfHaveInstalled        8       ///Obliged install driver directl
#define  IsShowMsg                        16      ///Show comment message box


///Rockey4 version list
#define  RK4_VER_1001                 0x00010001  ///Obsolete Rockey4 driver
#define  RK4_VER_2001                 0x00020001  ///Obsolete driver support dos utility
#define  RK4_VER_2002                 0x00020002  ///New certificated driver unsupport dos utility

#pragma once 

/*
Command line parameters:
   /?	Show command line parameter
   /i	Don't show interface, install direct
   /r 	Don't show interface, uninstall direct
   /s	 Slience mode, don't show interface and any message box
   /Dos  support dos utilities.
   /T0   Driver don't test parallel port busy(default)
   /T1   Test parallel port busy
   /P0   Both support parallel dongle and usb dongle(default)
   /P1   Support parallel dongle only
   /P2   Support usb dongle only
   /N    quit if have installed.
   /D278 Obliged 278 port when check parellel
   /D378 Obliged 378 port when check parellel
   /D3BC Obliged 3BC port when check parellel
   Sample:   Installer /i/s/Dos  Install the support dos driver without GUI.
*/

/*
Install or Uninstall Rockey4 driver

Parameter:
       bIsReBoot : User buffer , informed user if need reboot after install or uninstall 
       
       szCmdLine : command line ,it can not be NULL.
       Sample  : bool bIsReBoot ; 
             Rk4Setup( &bIsReBoot , "/i/Dos" ) ; 
Return Value:
          If the function fails ,the return value is 0 , when success return 1.
          If the course be canceled,  the return value is 2
*/         
INSTAPI int Rk4Setup( IN OUT bool *bIsReBoot , IN char* szCmdLine );

/*
Process In 64 bit system or 32 bit system

Return Value:
          If the return value is 1 , Process In  64 bit system .
          If the return value is 0 , Process In  32 bit system .
*/         

INSTAPI int Is64Process();

/*
Paser the command line which user input.

Parameter:
  pMode : Pointer to the buffer that receives the Install_Mode pasered by InstallDll.dll.
       szCmdLine  Command line be paseredthe parameter can not be NULL!
       Sample  :  int iMode;
              ParseCmdLine( &iMode , "/i/Dos" ) ;  
Return Value:
          If the function fails ,the return value is 0 , when success return 1.//   */        
INSTAPI int Rk4ParseCmdLine( IN OUT int *pMode , IN char* szCmdLine );



/*
  Check whether the several Rockey4 had be installed there before 

Parameter:
   NULL 
   
Return Value:
          If the function fails ,the return value is false , when success return true.   
*/
INSTAPI bool Rk4IsHaveInstall();

/*
Obtain the Rockey4 drvier version which had be installed there before.
Parameter:
   NULL 
Return Value:
          If the function fails ,the return value is 0 , return the driver version  
          when success ,detail informations see Rockey4 version list.

*/    
INSTAPI DWORD Rk4GetVersion();


/*
Reboot the Window Operation System

Parameter:
   NULL 
   
Return Value:
   NULL

*/      
INSTAPI void ReBoot();

///The following export function is applied for legacy . An application should use the new version setup function. 

///Retured Valude List
#define INST_ERROR_SUCCESS		0	//Setup success.
#define INST_ERROR_PARAMETER	1	//There ares some errors in parametersit may be incompatible or not specified either /i  or /r.
#define INST_ERROR_COPYFILE		2	//There are some errors in copy files.
#define INST_ERROR_NTREGISTRY	3	//Some errors occur while the specify Registery Key is opened.Try it with log on the system with the administrator. 
#define INST_ERROR_NTSTART		4	//Some errors occur while Win NT/2000 start . Try it by reboot.
#define INST_ERROR_OPENINF		5	//Some errors occur while open usb inf file.
#define INST_ERROR_NONEEDINSTALL 6  //The Rockey4 driver had be installed correctly and you need not to install it.

/*
Install Rockey4 Driver , private interface

Parameter:
    hwnd        Reserved
    szSrcDir    Reserved
    szSupport   Reserved
    szInst      Reserved
    szRes       Reserved

   
Return Value:
          If the function fails ,the return value is 0 , when success return 1.   
*/
INSTAPI CHAR  __stdcall  Foo(HWND hwnd, 
						   LPSTR szSrcDir, 
						   LPSTR szSupport, 
						   LPSTR szInst, 
						   LPSTR szRes );




/*
Install or Uninstall Rockey4 driver

Parameter:
       hwnd      Reserved
       lpIValue  Reserved
       lpszValue   command line ,the parameter can not be NULL.

Return Value:	  
    If the function success , the return value is 0 , otherwise the return value is nonzero. To get 
    extended error information , see the "Retured Valude List" please.
*/
INSTAPI LONG  __stdcall InstRockey(HWND hwnd, LPLONG lpIValue, LPSTR lpszValue);



/*
Whether or not need reboot the system after  the Rockey4 setup.

Parameters : 
        NULL
	  
Return Value:	  
    If the return value is 0, it express the system need not reboot .
    If the return value is 1, it express the system need reboot in order to the driver valid and work well.
        
*/
INSTAPI int  __stdcall  IsNeedRestart();

#endif